import React, { Component } from 'react';
import PropTypes from 'prop-types';
import Slider from 'react-rangeslider';
import 'react-rangeslider/lib/index.css';

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css = ".styles_image__13rbW {\n  position: absolute;\n  top: 0;\n  left: 0;\n}\n";
var stockStyles = { "image": "styles_image__13rbW" };
styleInject(css);

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();

var ImageLayer = function ImageLayer(_ref) {
  var className = _ref.className,
      alt = _ref.alt,
      src = _ref.src,
      size = _ref.size,
      zIndex = _ref.zIndex;
  return React.createElement("img", {
    className: stockStyles["image"] + " " + className,
    alt: alt,
    src: src,
    style: _extends({}, size, { zIndex: zIndex })
  });
};

ImageLayer.defaultProps = {
  className: "",
  alt: "",
  src: "",
  size: {
    width: 60,
    height: 160
  }
};

ImageLayer.propTypes = {
  className: PropTypes.string,
  alt: PropTypes.string,
  src: PropTypes.string.isRequired,
  zIndex: PropTypes.number,
  size: PropTypes.shape({
    width: PropTypes.number.isRequired,
    height: PropTypes.number.isRequired
  })
};

var css$1 = ".styles_curr-canvas-layer__1LRAH {\n  position: absolute;\n  top: 0;\n  left: 0;\n}\n";
var stockStyles$1 = { "curr-canvas-layer": "styles_curr-canvas-layer__1LRAH" };
styleInject(css$1);

var PointLayer = function (_Component) {
  inherits(PointLayer, _Component);

  function PointLayer(props) {
    classCallCheck(this, PointLayer);

    var _this = possibleConstructorReturn(this, (PointLayer.__proto__ || Object.getPrototypeOf(PointLayer)).call(this, props));

    _this.canvas = React.createRef();
    return _this;
  }

  createClass(PointLayer, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _props = this.props,
          dataArray = _props.dataArray,
          size = _props.size;

      this.drawByPoints(dataArray, size);
    }
  }, {
    key: "drawByPoints",
    value: function drawByPoints(dataArray, size) {
      var context = this.canvas.current.getContext("2d");
      var myImageData = new ImageData(dataArray, size.width, size.height);
      context.putImageData(myImageData, 0, 0);
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      var dataArray = nextProps.dataArray,
          size = nextProps.size;

      this.drawByPoints(dataArray, size);
      return true;
    }
  }, {
    key: "render",
    value: function render() {
      var _props$size = this.props.size,
          width = _props$size.width,
          height = _props$size.height;

      return React.createElement("canvas", {
        ref: this.canvas,
        width: width,
        height: height,
        className: stockStyles$1["curr-canvas-layer"] + " " + this.props.className,
        style: {
          zIndex: this.props.zIndex
        }
      });
    }
  }]);
  return PointLayer;
}(Component);


PointLayer.defaultProps = {
  className: "",
  size: {
    width: 60,
    height: 160
  }
};

PointLayer.propTypes = {
  className: PropTypes.string.isRequired,
  zIndex: PropTypes.number,
  size: PropTypes.shape({
    width: PropTypes.number,
    height: PropTypes.number
  }).isRequired,
  dataArray: PropTypes.object
};

var countFourthOfCircle = function countFourthOfCircle(primaryCoord, secondaryCoord, r) {
  var fourth = [];
  for (var i = Math.round(primaryCoord - r / Math.sqrt(2)); i <= primaryCoord + r; i++) {
    var sec = Math.round(Math.sqrt(Math.pow(r, 2) - Math.pow(i - primaryCoord, 2)) + secondaryCoord);
    var backSec = Math.round(-Math.sqrt(Math.pow(r, 2) - Math.pow(i - primaryCoord, 2)) + secondaryCoord);
    fourth.push({
      pr: i,
      sec: sec,
      backSec: backSec
    });
  }
  return fourth;
};

var createPointMapForCircle = function createPointMapForCircle(xC, yC, r) {
  var pointMap = Object.create(null);
  var primaryX = countFourthOfCircle(xC, yC, r);
  var primaryY = countFourthOfCircle(yC, xC, r);

  primaryX.forEach(function (el) {
    var pr = el.pr,
        sec = el.sec,
        backSec = el.backSec;

    pointMap[pr + " " + sec] = 1;
    pointMap[pr + " " + backSec] = 1;
  });

  primaryY.forEach(function (el) {
    var pr = el.pr,
        sec = el.sec,
        backSec = el.backSec;

    pointMap[sec + " " + pr] = 1;
    pointMap[backSec + " " + pr] = 1;
  });

  return pointMap;
};

var pointMapToArray = function pointMapToArray(pointMap) {
  var coordinates = [];
  for (var key in pointMap) {
    var _key$split$map = key.split(" ").map(function (c) {
      return +c;
    }),
        _key$split$map2 = slicedToArray(_key$split$map, 2),
        x = _key$split$map2[0],
        y = _key$split$map2[1];

    if (!coordinates[x]) {
      coordinates[x] = { minY: +Infinity, maxY: -Infinity };
    }
    coordinates[x].minY = coordinates[x].minY < y ? coordinates[x].minY : y;
    coordinates[x].maxY = coordinates[x].maxY > y ? coordinates[x].maxY : y;
  }
  var result = coordinates.map(function (_ref, index) {
    var minY = _ref.minY,
        maxY = _ref.maxY;

    return { x: index, yTopBorder: maxY, yBottomBorder: minY };
  }).filter(function (el) {
    return !!el;
  });
  return result;
};

var findVerticalPointLine = function findVerticalPointLine(x, yStart, yEnd, color) {
  var result = [];
  for (var y = yStart; y < yEnd; y++) {
    result.push({
      x: x,
      y: y,
      color: color
    });
  }
  return result;
};

function findUnfilledCircle(xCenter, yCenter, outerRadius, innerRadius, color) {
  var result = [];
  var circleOuterBorder = findCircleBorder(xCenter, yCenter, outerRadius);
  var circleInnerBorder = findCircleBorder(xCenter, yCenter, innerRadius);
  var separator = Math.ceil(outerRadius - innerRadius);
  for (var i = 0; i < separator; i++) {
    var _circleOuterBorder$i = circleOuterBorder[i],
        xL = _circleOuterBorder$i.x,
        yTopBorderL = _circleOuterBorder$i.yTopBorder,
        yBottomBorderL = _circleOuterBorder$i.yBottomBorder;
    var _circleOuterBorder = circleOuterBorder[circleOuterBorder.length - i - 1],
        xR = _circleOuterBorder.x,
        yTopBorderR = _circleOuterBorder.yTopBorder,
        yBottomBorderR = _circleOuterBorder.yBottomBorder;

    result = result.concat(findVerticalPointLine(xL, yBottomBorderL, yTopBorderL, color)).concat(findVerticalPointLine(xR, yBottomBorderR, yTopBorderR, color));
  }
  for (var _i = separator; _i < circleOuterBorder.length - separator; _i++) {
    var _circleOuterBorder$_i = circleOuterBorder[_i],
        x = _circleOuterBorder$_i.x,
        yTopBorderOuter = _circleOuterBorder$_i.yTopBorder,
        yBottomBorderOuter = _circleOuterBorder$_i.yBottomBorder;
    var _circleInnerBorder = circleInnerBorder[_i - separator],
        yTopBorderInner = _circleInnerBorder.yTopBorder,
        yBottomBorderInner = _circleInnerBorder.yBottomBorder;


    result = result.concat(findVerticalPointLine(x, yTopBorderInner, yTopBorderOuter, color)).concat(findVerticalPointLine(x, yBottomBorderOuter, yBottomBorderInner, color));
  }
  return result;
}

function findFilledCircle(xCenter, yCenter, radius, color) {
  var result = [];
  var circleBorder = findCircleBorder(xCenter, yCenter, radius);
  circleBorder.forEach(function (el) {
    var x = el.x,
        yTopBorder = el.yTopBorder,
        yBottomBorder = el.yBottomBorder;

    for (var iy = yBottomBorder; iy <= yTopBorder; iy++) {
      result.push({
        x: x,
        y: iy,
        color: color
      });
    }
  });
  return result;
}

function findCircleBorder(xCenter, yCenter, radius) {
  var pointMap = createPointMapForCircle(xCenter, yCenter, radius);
  var coordinates = pointMapToArray(pointMap);
  return coordinates;
}

function countDistance(xStart, yStart, xEnd, yEnd) {
  return Math.floor(Math.sqrt(Math.pow(xStart - xEnd, 2) + Math.pow(yStart - yEnd, 2)));
}

var transposedCoord = function transposedCoord(xToTransp, yToTransp, height) {
  return {
    xTransp: xToTransp,
    yTransp: height - yToTransp
  };
};

var getProjectedPoint = function getProjectedPoint(currCoords, currSize, reqSize) {
  var coef = currSize.width / reqSize.width;
  return {
    xCoef: Math.floor(currCoords.x * coef),
    yCoef: Math.floor(currCoords.y * coef)
  };
};

var separateData = function separateData(dataSet3d) {
  if (!Array.isArray(dataSet3d)) {
    return [];
  }
  var dataArrayCoronal = [];

  var dataArraySagittal = [];

  var dataArrayTransverse = [];
  dataSet3d.forEach(function (layer) {
    layer.forEach(function (layerPoint) {
      var x = layerPoint.x,
          y = layerPoint.y,
          z = layerPoint.z,
          color = layerPoint.color;

      dataArrayCoronal.push({ x: x, y: y, color: color });
      dataArraySagittal.push({ x: y, y: z, color: color });
      dataArrayTransverse.push({ x: x, y: z, color: color });
    });
  });
  return { dataArrayCoronal: dataArrayCoronal, dataArraySagittal: dataArraySagittal, dataArrayTransverse: dataArrayTransverse };
};

var utils = /*#__PURE__*/Object.freeze({
  findUnfilledCircle: findUnfilledCircle,
  findFilledCircle: findFilledCircle,
  findCircleBorder: findCircleBorder,
  countDistance: countDistance,
  transposedCoord: transposedCoord,
  getProjectedPoint: getProjectedPoint,
  separateData: separateData
});

var supposedDataSizes = {
  DATA_WIDTH: 60,
  DATA_HEIGHT: 160,
  DATA_DEPTH: 45
};
var crossColors = {
  CORONAL_COLOR: "rgba(255, 0, 0, 0.6)",
  SAGITTAL_COLOR: "rgba(0, 0, 255, 0.6)",
  TRANSVERSE_COLOR: "rgba(0, 255, 0, 0.6)"
};

var toolboxRoiValues = {
  ERASE: "erase",
  FILL: "fill",
  VOID: "void"
};

var toolboxSelectColors = {
  GREEN: "rgba(124, 179, 66, 1)",
  GREY: "rgba(179, 179, 179, 1)"
};

var constants = /*#__PURE__*/Object.freeze({
  supposedDataSizes: supposedDataSizes,
  crossColors: crossColors,
  toolboxRoiValues: toolboxRoiValues,
  toolboxSelectColors: toolboxSelectColors
});

var css$2 = ".styles_view-layer__2mLS9 {\n  position: relative;\n}\n";
var stockStyles$2 = { "view-layer": "styles_view-layer__2mLS9" };
styleInject(css$2);

var DATA_WIDTH = supposedDataSizes.DATA_WIDTH,
    DATA_HEIGHT = supposedDataSizes.DATA_HEIGHT;

var View = function (_Component) {
  inherits(View, _Component);

  function View() {
    var _ref;

    var _temp, _this, _ret;

    classCallCheck(this, View);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = possibleConstructorReturn(this, (_ref = View.__proto__ || Object.getPrototypeOf(View)).call.apply(_ref, [this].concat(args))), _this), _this.provideArguments = function (event) {
      var _event$target$getBoun = event.target.getBoundingClientRect(),
          x = _event$target$getBoun.x,
          y = _event$target$getBoun.y;

      var elemCoords = {
        x: Math.ceil(event.clientX - x),
        y: Math.ceil(event.clientY - y)
      };
      var transpCoords = transposedCoord(elemCoords.x, elemCoords.y, _this.props.size.height);
      var displayCoodrs = {
        x: transpCoords.xTransp,
        y: transpCoords.yTransp
      };
      var projCoords = getProjectedPoint(displayCoodrs, _this.props.dataSize, _this.props.size);
      var dataCoords = {
        x: projCoords.xCoef,
        y: projCoords.yCoef
      };
      _this.props.onClick(elemCoords, dataCoords);
    }, _this.handleWheel = function (event) {
      if (_this.props.onWheel) {
        event.preventDefault();
        _this.props.onWheel(event);
      }
    }, _temp), possibleConstructorReturn(_this, _ret);
  }

  createClass(View, [{
    key: "render",
    value: function render() {
      var _props = this.props,
          size = _props.size,
          className = _props.className,
          _props$size = _props.size,
          width = _props$size.width,
          height = _props$size.height,
          styles = _props.styles,
          children = _props.children;

      return React.createElement(
        "div",
        {
          role: "presentation",
          className: stockStyles$2["view-layer"] + " " + className,
          onClick: this.provideArguments,
          onWheel: this.handleWheel,
          style: _extends({}, styles, { width: width, height: height })
        },
        React.Children.map(children, function (child, index) {
          return React.cloneElement(child, {
            zIndex: 100 - index,
            size: size
          });
        })
      );
    }
  }]);
  return View;
}(Component);


View.defaultProps = {
  className: "",
  onClick: function onClick(displayCoords, dataCoords) {},
  dataSize: {
    width: DATA_WIDTH,
    height: DATA_HEIGHT
  }
};

View.propTypes = {
  className: PropTypes.string.isRequired,
  style: PropTypes.object,
  onClick: PropTypes.func.isRequired,
  onWheel: PropTypes.func,
  size: PropTypes.shape({
    width: PropTypes.number.isRequired,
    height: PropTypes.number.isRequired
  }).isRequired,
  dataSize: PropTypes.shape({
    width: PropTypes.number.isRequired,
    height: PropTypes.number.isRequired
  }).isRequired
};

var UIntArrayShaper = function () {
  function UIntArrayShaper(dataWidth, dataHeight, width, height, points, radius) {
    var _this = this;

    classCallCheck(this, UIntArrayShaper);

    this._findScaledPointArea = function (x, y, color) {
      var xScaleCoef = _this._width / _this._dataWidth;
      var yScaleCoef = _this._height / _this._dataHeight;
      var resultArea = [];
      for (var ix = x; ix < x + xScaleCoef; ix++) {
        for (var iy = y - 1; iy > y - 1 - yScaleCoef; iy--) {
          resultArea.push({ x: ix, y: iy, color: color });
        }
      }
      return resultArea;
    };

    this._fillCircleByPoint = function (r, xC, yC, color) {
      var resultArea = [];
      var xScaleCoef = Math.ceil(_this._width / _this._dataWidth);
      var yScaleCoef = Math.ceil(_this._height / _this._dataHeight);
      var circleBorder = findFilledCircle(xC, yC, r);
      circleBorder = circleBorder.filter(function (element) {
        return element.x < _this._width;
      });
      circleBorder.forEach(function (element) {
        var x = element.x,
            y = element.y;

        var newAlpha = _this._countGradientAlpha(xC, yC, x, y, xScaleCoef, yScaleCoef, color.a, r);

        var newColor = _extends({}, color, {
          a: newAlpha
        });
        resultArea.push({ x: x, y: y, color: newColor });
      });
      return resultArea;
    };

    this._uIntArr = new Uint8ClampedArray(width * height * 4);
    this._dataHeight = dataHeight;
    this._dataWidth = dataWidth;
    this._width = width;
    this._height = height;
    if (points) {
      if (radius) {
        this.fillCirclesByPoints(points, radius);
      } else {
        this.fillScaledPoints(points);
      }
    }
  }

  createClass(UIntArrayShaper, [{
    key: "fillScaledPoints",
    value: function fillScaledPoints(points) {
      this._fillPointArray(points, this._findScaledPointArea);
    }
  }, {
    key: "fillCirclesByPoints",
    value: function fillCirclesByPoints(points, radius) {
      var r = radius || this._width / this._dataWidth * 2;
      this._fillPointArray(points, this._fillCircleByPoint.bind(this, r));
    }
  }, {
    key: "getData",
    value: function getData() {
      return this._uIntArr;
    }
  }, {
    key: "_fillPointArray",
    value: function _fillPointArray(points, transformAreaFunction) {
      var _this2 = this;

      points.forEach(function (point) {
        var x = point.x,
            y = point.y,
            color = point.color;


        var currSize = { width: _this2._width, height: _this2._height };
        var reqSize = { width: _this2._dataWidth, height: _this2._dataHeight };

        var _transposedCoord = transposedCoord(x, y, _this2._dataHeight),
            xTransp = _transposedCoord.xTransp,
            yTransp = _transposedCoord.yTransp;

        var _getProjectedPoint = getProjectedPoint({ x: xTransp, y: yTransp }, currSize, reqSize),
            xCoef = _getProjectedPoint.xCoef,
            yCoef = _getProjectedPoint.yCoef;

        var area = transformAreaFunction(xCoef, yCoef, color);
        area.forEach(function (_ref) {
          var x = _ref.x,
              y = _ref.y,
              color = _ref.color;
          return _this2._fillOnePoint(x, y, color);
        });
      });
    }
  }, {
    key: "_fillOnePoint",
    value: function _fillOnePoint(x, y, color) {
      var indexRed = y * this._width * 4 + x * 4;
      this._uIntArr[indexRed] = color.r;
      this._uIntArr[indexRed + 1] = color.g;
      this._uIntArr[indexRed + 2] = color.b;
      this._uIntArr[indexRed + 3] = this._uIntArr[indexRed + 3] < color.a ? color.a : this._uIntArr[indexRed + 3];
    }
  }, {
    key: "_countGradientAlpha",
    value: function _countGradientAlpha(xCenter, yCenter, x, y, xScaleCoef, yScaleCoef, maxAlpha, radius) {
      var maxA = maxAlpha || 255;
      var distFromCenter = countDistance(xCenter + xScaleCoef / 2 - 1, yCenter + yScaleCoef / 2 - 1, x, y);
      return Math.round(maxA * (1 - distFromCenter / radius));
    }
  }]);
  return UIntArrayShaper;
}();

var css$3 = ".styles_slicer-guide-lines__28pRd {\n  position: absolute;\n  top: 0;\n  left: 0;\n}\n";
var stockStyles$3 = { "slicer-guide-lines": "styles_slicer-guide-lines__28pRd" };
styleInject(css$3);

var SlicerGuideLines = function (_Component) {
  inherits(SlicerGuideLines, _Component);

  function SlicerGuideLines(props) {
    classCallCheck(this, SlicerGuideLines);

    var _this = possibleConstructorReturn(this, (SlicerGuideLines.__proto__ || Object.getPrototypeOf(SlicerGuideLines)).call(this, props));

    _this.canvas = React.createRef();
    return _this;
  }

  createClass(SlicerGuideLines, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _props = this.props,
          cross = _props.cross,
          thickness = _props.thickness,
          colors = _props.colors;

      this.drawСross(cross, thickness, colors);
    }
  }, {
    key: "drawColorLine",
    value: function drawColorLine(context, from, to, thickness, color) {
      context.beginPath();
      context.moveTo(from.x, from.y);
      context.lineTo(to.x, to.y);
      context.lineWidth = thickness;
      context.strokeStyle = color;
      context.stroke();
    }
  }, {
    key: "draw\u0421ross",
    value: function drawRoss(cross, thickness, colors) {
      var context = this.canvas.current.getContext("2d");
      var x = cross.x,
          y = cross.y;
      var _props$size = this.props.size,
          width = _props$size.width,
          height = _props$size.height;

      context.clearRect(0, 0, width, height);
      var v = colors.v,
          h = colors.h;

      this.drawColorLine(context, { x: x, y: 0 }, { x: x, y: height }, thickness, v);
      this.drawColorLine(context, { x: 0, y: y }, { x: width, y: y }, thickness, h);
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      var cross = nextProps.cross,
          thickness = nextProps.thickness,
          colors = nextProps.colors;

      this.drawСross(cross, thickness, colors);
      return true;
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement("canvas", {
        ref: this.canvas,
        width: this.props.size.width,
        height: this.props.size.height,
        className: stockStyles$3["slicer-guide-lines"] + " " + this.props.className,
        style: { zIndex: this.props.zIndex }
      });
    }
  }]);
  return SlicerGuideLines;
}(Component);


SlicerGuideLines.defaultProps = {
  className: ""
};

SlicerGuideLines.propTypes = {
  className: PropTypes.string.isRequired,
  zIndex: PropTypes.number,
  size: PropTypes.shape({
    width: PropTypes.number,
    height: PropTypes.number
  }),
  cross: PropTypes.shape({
    x: PropTypes.number,
    y: PropTypes.number
  }).isRequired,
  thickness: PropTypes.number.isRequired,
  colors: PropTypes.shape({
    v: PropTypes.string.isRequired,
    h: PropTypes.string.isRequired
  })
};

var css$4 = ".styles_roi-toolbox-cont__1ZqnY {\n  display: flex;\n  flex-direction: column;\n  align-items: center;\n}\n\n.styles_roi-toolbox-elem__2dARq {\n  margin-top: 2px;\n  margin-bottom: 6px;\n}\n";
var stockStyles$4 = { "roi-toolbox-cont": "styles_roi-toolbox-cont__1ZqnY", "roi-toolbox-elem": "styles_roi-toolbox-elem__2dARq" };
styleInject(css$4);

var RoiToolbox = function (_Component) {
  inherits(RoiToolbox, _Component);

  function RoiToolbox(props) {
    classCallCheck(this, RoiToolbox);

    var _this = possibleConstructorReturn(this, (RoiToolbox.__proto__ || Object.getPrototypeOf(RoiToolbox)).call(this, props));

    _this.handleChangeComplete = function () {
      var _this$state = _this.state,
          value = _this$state.value,
          radius = _this$state.radius;

      _this.props.onToolChange({ roiToolbox: { value: value, radius: radius } });
    };

    _this.handleChange = function (subState) {
      _this.setState(subState);
    };

    var _this$props = _this.props,
        width = _this$props.width,
        color = _this$props.color;

    var circles = createDataArrays(width, color);
    _this.state = {
      circles: circles,
      value: toolboxRoiValues.VOID,
      radius: 6
    };
    return _this;
  }

  createClass(RoiToolbox, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _state = this.state,
          value = _state.value,
          radius = _state.radius,
          _state$circles = _state.circles,
          selectedFilled = _state$circles.selectedFilledData,
          unselectedFilled = _state$circles.unselectedFilledData,
          selected = _state$circles.selectedData,
          unselected = _state$circles.unselectedData;
      var _props = this.props,
          width = _props.width,
          color = _props.color;

      var selectColor = color || toolboxSelectColors.GREEN;

      var size = {
        width: width,
        height: width
      };

      return React.createElement(
        "div",
        { className: stockStyles$4["roi-toolbox-cont"] },
        React.createElement(
          View,
          {
            className: stockStyles$4["roi-toolbox-elem"],
            size: size,
            onClick: function onClick() {
              _this2.setState({ value: toolboxRoiValues.VOID }, _this2.handleChangeComplete());
            },
            styles: value === toolboxRoiValues.VOID ? { boxShadow: "0 0 1px 1px " + selectColor, borderRadius: "5%" } : null
          },
          React.createElement(SlicerGuideLines, {
            cross: { x: width / 2, y: width / 2 },
            thickness: 1,
            colors: value === toolboxRoiValues.VOID ? { v: selectColor, h: selectColor } : { v: toolboxSelectColors.GREY, h: toolboxSelectColors.GREY }
          })
        ),
        React.createElement(
          View,
          {
            className: stockStyles$4["roi-toolbox-elem"],
            size: size,
            onClick: function onClick() {
              _this2.setState({ value: toolboxRoiValues.FILL }, _this2.handleChangeComplete());
            },
            styles: value === toolboxRoiValues.FILL ? { boxShadow: "0 0 1px 1px " + toolboxSelectColors.GREY, borderRadius: "5%" } : null
          },
          React.createElement(PointLayer, {
            dataArray: value === toolboxRoiValues.FILL ? selectedFilled.getData() : unselectedFilled.getData()
          })
        ),
        React.createElement(
          View,
          {
            className: stockStyles$4["roi-toolbox-elem"],
            size: size,
            onClick: function onClick() {
              _this2.setState({ value: toolboxRoiValues.ERASE }, _this2.handleChangeComplete());
            },
            styles: value === toolboxRoiValues.ERASE ? { boxShadow: "0 0 1px 1px " + selectColor, borderRadius: "5%" } : null
          },
          React.createElement(PointLayer, {
            dataArray: value === toolboxRoiValues.ERASE ? selected.getData() : unselected.getData()
          })
        ),
        React.createElement(Slider, {
          min: 1,
          max: 20,
          step: 1,
          value: radius,
          orientation: "vertical",
          tooltip: true,
          onChange: function onChange(currentRadius) {
            _this2.handleChange({ radius: currentRadius });
          },
          onChangeComplete: this.handleChangeComplete
        }),
        React.createElement(
          "span",
          null,
          this.state.radius
        )
      );
    }
  }]);
  return RoiToolbox;
}(Component);


RoiToolbox.defaultProps = {
  className: ""
};

RoiToolbox.propTypes = {
  className: PropTypes.string,
  onToolChange: PropTypes.func.isRequired,
  width: PropTypes.number,
  color: PropTypes.string
};

var createDataArrays = function createDataArrays(width, color) {
  var center = Math.floor(width / 2);
  var radius = Math.floor(width / 2.8);

  var activeRGBA = color || stringRGBAtoObject(toolboxSelectColors.GREEN);
  var greyRGBA = stringRGBAtoObject(toolboxSelectColors.GREY);

  var filledCircle = findFilledCircle(center, center, radius);
  var unfilledCircle = findUnfilledCircle(center, center, radius, radius - 1);

  var filledCirclePicked = fillArrayWithColor(filledCircle, activeRGBA);
  var filledCircleUnpicked = fillArrayWithColor(filledCircle, greyRGBA);
  var unfilledCirclePicked = fillArrayWithColor(unfilledCircle, activeRGBA);
  var unfilledCircleUnpicked = fillArrayWithColor(unfilledCircle, greyRGBA);

  var selectedFilledData = createSquareUIntArraySharper(width, filledCirclePicked);

  var unselectedFilledData = createSquareUIntArraySharper(width, filledCircleUnpicked);

  var selectedData = createSquareUIntArraySharper(width, unfilledCirclePicked);

  var unselectedData = createSquareUIntArraySharper(width, unfilledCircleUnpicked);
  return {
    selectedFilledData: selectedFilledData,
    unselectedFilledData: unselectedFilledData,
    selectedData: selectedData,
    unselectedData: unselectedData
  };
};

var fillArrayWithColor = function fillArrayWithColor(array, color) {
  return array.map(function (_ref) {
    var x = _ref.x,
        y = _ref.y;
    return {
      x: x,
      y: y,
      color: color
    };
  });
};

var createSquareUIntArraySharper = function createSquareUIntArraySharper(side, dataArray) {
  return new UIntArrayShaper(side, side, side, side, dataArray);
};

var stringRGBAtoObject = function stringRGBAtoObject(color) {
  var colors = color.replace(/[^0-9|,|.]*/g, "").split(",").map(function (str) {
    return +str;
  });
  return {
    r: colors[0],
    g: colors[1],
    b: colors[2],
    a: Math.round(colors[3] * 255)
  };
};

var css$5 = ".styles_letter-layer__13Mo6 {\n  position: absolute;\n  top: 0;\n  left: 0;\n}\n";
var stockStyles$5 = { "letter-layer": "styles_letter-layer__13Mo6" };
styleInject(css$5);

var LettersLayer = function (_Component) {
  inherits(LettersLayer, _Component);

  function LettersLayer(props) {
    classCallCheck(this, LettersLayer);

    var _this = possibleConstructorReturn(this, (LettersLayer.__proto__ || Object.getPrototypeOf(LettersLayer)).call(this, props));

    _this.canvas = React.createRef();
    return _this;
  }

  createClass(LettersLayer, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _props = this.props,
          letters = _props.letters,
          color = _props.color,
          fontSize = _props.fontSize;

      this.drawSideLetters(letters, color, fontSize);
    }
  }, {
    key: "drawSideLetters",
    value: function drawSideLetters(letters, color, fontSize) {
      var _props$size = this.props.size,
          width = _props$size.width,
          height = _props$size.height;

      var context = this.canvas.current.getContext("2d");
      context.font = fontSize + "px Arial";
      context.fillStyle = color;
      var ltrs = letters.toUpperCase();
      context.fillText(ltrs[0], width / 2 - fontSize / 4, fontSize);
      context.fillText(ltrs[1], width - fontSize, height / 2);
      context.fillText(ltrs[2], width / 2 - fontSize / 4, height - fontSize / 4);
      context.fillText(ltrs[3], 2, height / 2);
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      return false;
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement("canvas", {
        ref: this.canvas,
        width: this.props.size.width,
        height: this.props.size.height,
        className: stockStyles$5["letter-layer"] + " " + this.props.className,
        style: { zIndex: this.props.zIndex }
      });
    }
  }]);
  return LettersLayer;
}(Component);


LettersLayer.defaultProps = {
  className: "",
  color: "#fff",
  fontSize: 20
};

LettersLayer.propTypes = {
  className: PropTypes.string.isRequired,
  zIndex: PropTypes.number,
  size: PropTypes.shape({
    width: PropTypes.number,
    height: PropTypes.number
  }),
  letters: PropTypes.string.isRequired,
  color: PropTypes.string.isRequired,
  fontSize: PropTypes.number.isRequired
};

var css$6 = ".styles_grid-slicer-container__ou6wK {\n  display: grid;\n  grid-template-rows: auto auto;\n  grid-template-columns: auto auto;\n  grid-gap: 10px;\n}\n\n.styles_title-view-container__1gkZz {\n  text-align: center;\n  height: 1em;\n}\n\n.styles_title__3MJvm {\n  height: 40px;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n}\n";
var stockStyles$6 = { "grid-slicer-container": "styles_grid-slicer-container__ou6wK", "title-view-container": "styles_title-view-container__1gkZz", "title": "styles_title__3MJvm" };
styleInject(css$6);

var DATA_WIDTH$1 = supposedDataSizes.DATA_WIDTH,
    DATA_HEIGHT$1 = supposedDataSizes.DATA_HEIGHT,
    DATA_DEPTH = supposedDataSizes.DATA_DEPTH;
var CORONAL_COLOR = crossColors.CORONAL_COLOR,
    SAGITTAL_COLOR = crossColors.SAGITTAL_COLOR,
    TRANSVERSE_COLOR = crossColors.TRANSVERSE_COLOR;

var Slicer = function (_Component) {
  inherits(Slicer, _Component);

  function Slicer(props) {
    classCallCheck(this, Slicer);

    var _this = possibleConstructorReturn(this, (Slicer.__proto__ || Object.getPrototypeOf(Slicer)).call(this, props));

    _initialiseProps.call(_this);

    var _this$props = _this.props,
        _this$props$size = _this$props.size,
        width = _this$props$size.width,
        height = _this$props$size.height,
        depth = _this$props$size.depth,
        dataW = _this$props.dataSize.width;

    _this.state = {
      quotient: width / dataW,
      slicerX: width / 2,
      slicerY: height / 2,
      slicerZ: depth / 2
    };
    return _this;
  }

  createClass(Slicer, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          _props$size = _props.size,
          width = _props$size.width,
          height = _props$size.height,
          depth = _props$size.depth,
          _props$lettersLayer = _props.lettersLayer,
          fontSize = _props$lettersLayer.fontSize,
          color = _props$lettersLayer.color;

      var style = {
        width: width + depth + 20,
        height: height + depth + 20
      };
      var combiner = this.combineDataArray();

      return React.createElement(
        "div",
        { className: stockStyles$6["grid-slicer-container"], style: style },
        combiner.map(function (plane, i) {
          var dataSize = plane.dataSize,
              layers = plane.layers,
              onClick = plane.onClick,
              onWheel = plane.onWheel,
              size = plane.size,
              _plane$slicerScopePro = plane.slicerScopeProps,
              cross = _plane$slicerScopePro.cross,
              colors = _plane$slicerScopePro.colors,
              letters = plane.letters,
              title = plane.title;

          return React.createElement(
            "div",
            {
              key: letters,
              className: stockStyles$6["title-view-container"],
              style: { width: size.width, height: size.height + 40 }
            },
            i !== 2 ? React.createElement(
              "div",
              { className: stockStyles$6.title },
              title
            ) : "",
            React.createElement(
              View,
              {
                onClick: onClick,
                onWheel: onWheel,
                size: size,
                dataSize: dataSize
              },
              React.createElement(LettersLayer, {
                fontSize: fontSize || 18,
                color: color || "#000",
                letters: letters
              }),
              React.createElement(SlicerGuideLines, {
                cross: cross,
                thickness: _this2.state.quotient / 2,
                colors: colors
              }),
              layers.map(function (elem, i) {
                var props = elem.props;

                var element = React.createElement(elem.component, _extends({ key: letters + "_" + i }, props));
                return element;
              })
            ),
            i === 2 ? React.createElement(
              "div",
              { className: stockStyles$6.title },
              title
            ) : ""
          );
        })
      );
    }
  }]);
  return Slicer;
}(Component);

var _initialiseProps = function _initialiseProps() {
  var _this3 = this;

  this.handleClick = function (currDisplayCoords, currDataCoords) {
    var _state = _this3.state,
        slicerX = _state.slicerX,
        slicerY = _state.slicerY,
        slicerZ = _state.slicerZ,
        quotient = _state.quotient;

    var dataCoords = {
      x: Math.floor(slicerX / quotient),
      y: Math.floor(slicerY / quotient),
      z: Math.floor(slicerZ / quotient)
    };
    _this3.props.onClick(_extends({}, dataCoords, currDataCoords));
    _this3.setState(_extends({}, currDisplayCoords));
  };

  this.handleClickCoronal = function (displayCoords, dataCoords) {
    var slicerX = displayCoords.x,
        slicerY = displayCoords.y;

    _this3.handleClick({ slicerX: slicerX, slicerY: slicerY }, dataCoords);
  };

  this.handleClickSagittal = function (displayCoords, dataCoords) {
    var slicerZ = displayCoords.x,
        slicerY = displayCoords.y;
    var z = dataCoords.x,
        y = dataCoords.y;

    _this3.handleClick({ slicerY: slicerY, slicerZ: slicerZ }, { y: y, z: z });
  };

  this.handleClickTransverse = function (displayCoords, dataCoords) {
    var _props$size2 = _this3.props.size,
        height = _props$size2.height,
        depth = _props$size2.depth;
    var _state2 = _this3.state,
        slicerY = _state2.slicerY,
        quotient = _state2.quotient;

    var y = Math.ceil((height - slicerY) / quotient);
    var slicerX = displayCoords.x,
        slicerZ = displayCoords.y;
    var x = dataCoords.x,
        z = dataCoords.y;

    _this3.handleClick({ slicerX: slicerX, slicerZ: depth - slicerZ }, { x: x, y: y, z: z });
  };

  this.triggerOnClickWithSlice = function () {
    var _state3 = _this3.state,
        slicerX = _state3.slicerX,
        slicerY = _state3.slicerY,
        slicerZ = _state3.slicerZ,
        quotient = _state3.quotient;

    _this3.props.onClick({
      x: Math.floor(slicerX / quotient),
      y: Math.floor((_this3.props.size.height - slicerY) / quotient),
      z: Math.floor(slicerZ / quotient)
    });
  };

  this.handleWheel = function (slicerCoord, deltaY, topBound) {
    var key = Object.keys(slicerCoord)[0];
    var coord = Object.assign({}, slicerCoord);
    var buffer = coord[key] + deltaY / 53;
    if (buffer < topBound && buffer >= 0) {
      coord[key] = buffer;
      _this3.setState(_extends({}, coord));
      _this3.triggerOnClickWithSlice();
    }
  };

  this.handleWheelCoronal = function (event) {
    var slicerZ = _this3.state.slicerZ;

    _this3.handleWheel({ slicerZ: slicerZ }, event.deltaY, _this3.props.size.depth);
  };

  this.handleWheelSagittal = function (event) {
    var slicerX = _this3.state.slicerX;

    _this3.handleWheel({ slicerX: slicerX }, event.deltaY, _this3.props.size.width);
  };

  this.handleWheelTransverse = function (event) {
    var slicerY = _this3.state.slicerY;

    _this3.handleWheel({ slicerY: slicerY }, event.deltaY, _this3.props.size.height);
  };

  this.combineDataArray = function () {
    var _props2 = _this3.props,
        _props2$size = _props2.size,
        width = _props2$size.width,
        height = _props2$size.height,
        depth = _props2$size.depth,
        _props2$dataSize = _props2.dataSize,
        dataWidth = _props2$dataSize.width,
        dataHeiht = _props2$dataSize.height,
        dataDepth = _props2$dataSize.depth,
        coronal = _props2.coronal,
        sagittal = _props2.sagittal,
        transverse = _props2.transverse;
    var _state4 = _this3.state,
        slicerX = _state4.slicerX,
        slicerY = _state4.slicerY,
        slicerZ = _state4.slicerZ;


    return [{
      onWheel: _this3.handleWheelCoronal,
      onClick: _this3.handleClickCoronal,
      size: { width: width, height: height },
      dataSize: { width: dataWidth, height: dataHeiht },
      layers: coronal,
      slicerScopeProps: {
        cross: { x: slicerX, y: slicerY },
        colors: { v: SAGITTAL_COLOR, h: TRANSVERSE_COLOR }
      },
      letters: "arpl",
      title: "Coronal"
    }, {
      onWheel: _this3.handleWheelSagittal,
      onClick: _this3.handleClickSagittal,
      size: { width: depth, height: height },
      dataSize: { width: dataDepth, height: dataHeiht },
      layers: sagittal,
      slicerScopeProps: {
        cross: { x: slicerZ, y: slicerY },
        colors: { v: CORONAL_COLOR, h: TRANSVERSE_COLOR }
      },
      letters: "adpv",
      title: "Sagittal"
    }, {
      onWheel: _this3.handleWheelTransverse,
      onClick: _this3.handleClickTransverse,
      size: { width: width, height: depth },
      dataSize: { width: dataWidth, height: dataDepth },
      layers: transverse,
      slicerScopeProps: {
        cross: { x: slicerX, y: depth - slicerZ },
        colors: { v: SAGITTAL_COLOR, h: CORONAL_COLOR }
      },
      letters: "drvl",
      title: "Transverse"
    }];
  };
};


Slicer.defaultProps = {
  dataSize: {
    width: DATA_WIDTH$1,
    height: DATA_HEIGHT$1,
    depth: DATA_DEPTH
  },
  onClick: function onClick(dataCoords) {},
  coronal: [],
  sagittal: [],
  transverse: [],
  lettersLayer: {}
};

Slicer.propTypes = {
  onClick: PropTypes.func.isRequired,
  size: PropTypes.shape({
    width: PropTypes.number.isRequired,
    height: PropTypes.number.isRequired,
    depth: PropTypes.number.isRequired
  }).isRequired,
  dataSize: PropTypes.shape({
    width: PropTypes.number.isRequired,
    height: PropTypes.number.isRequired,
    depth: PropTypes.number.isRequired
  }).isRequired,
  coronal: PropTypes.arrayOf(PropTypes.shape({
    component: PropTypes.any.isRequired,
    props: PropTypes.any.isRequired
  })).isRequired,
  sagittal: PropTypes.arrayOf(PropTypes.shape({
    component: PropTypes.any.isRequired,
    props: PropTypes.any.isRequired
  })).isRequired,
  transverse: PropTypes.arrayOf(PropTypes.shape({
    component: PropTypes.any.isRequired,
    props: PropTypes.any.isRequired
  })).isRequired,
  lettersLayer: PropTypes.shape({
    fontSize: PropTypes.number,
    color: PropTypes.string
  })
};

function formPlanarWithThreeDimensional(sizes, dataSizes, pointArray, radius) {
  var width = sizes.width,
      height = sizes.height,
      depth = sizes.depth;
  var dataWidth = dataSizes.dataWidth,
      dataHeight = dataSizes.dataHeight,
      dataDepth = dataSizes.dataDepth;


  var coronal = new UIntArrayShaper(dataWidth, dataHeight, width, height, pointArray.map(function (element) {
    var x = element.x,
        y = element.y,
        color = element.color;

    return {
      x: x,
      y: y,
      color: color
    };
  }), radius);
  var sagittal = new UIntArrayShaper(dataDepth, dataHeight, depth, height, pointArray.map(function (element) {
    var y = element.y,
        z = element.z,
        color = element.color;

    return {
      x: z,
      y: y,
      color: color
    };
  }), radius);
  var transverse = new UIntArrayShaper(dataWidth, dataDepth, width, depth, pointArray.map(function (element) {
    var x = element.x,
        z = element.z,
        color = element.color;

    return {
      x: x,
      y: z,
      color: color
    };
  }), radius);
  return {
    coronal: coronal.getData(),
    sagittal: sagittal.getData(),
    transverse: transverse.getData()
  };
}

export { ImageLayer, PointLayer, Slicer, formPlanarWithThreeDimensional, View, UIntArrayShaper as UIntArraySharper, utils, RoiToolbox, constants };
//# sourceMappingURL=index.es.js.map
